/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;

namespace ShopClassLibrary
{
	/// <summary>
	/// Summary description for Comum.
	/// </summary>
	internal class UtilDB
	{
		//private const string DEFAULT_CONN = @"Provider=Microsoft.Jet.OLEDB.4.0;User ID=;Password=;Mode=Share Deny None;";
        private const string DEFAULT_CONN = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=";

        private const string DEFAULT_DBPATH = @"C:\Documents and Settings\Teofilo\Desktop\adav\ShopPag\Sales.mdb";

		public static string CONN
		{
			get { return DEFAULT_CONN + DEFAULT_DBPATH; }
		}

		public UtilDB()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		#region ValidateUser

		/// <summary>
		/// Valida um login/password no sistema
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns></returns>
		static public ShopStatusEnum ValidateUser(string user, string pass)
		{
			ShopStatusEnum status = ShopStatusEnum.OK;
			OleDbConnection conn = null;

			try
			{
				//
				// criar objecto de conexo  base de dados e abrir a conexo
				//
				conn = new OleDbConnection(CONN);
				conn.Open();

				//
				// invocar mtodo auxiliar
				//
				status = ValidateUser(conn, null, user, pass);
			}
			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO na validao do 'User': " + ex);
				status = ShopStatusEnum.ERROR;
			}
			finally
			{
				//
				// fechar a conexo
				//
				if (conn.State == ConnectionState.Open)
					conn.Close();
			}

			return status;
		}

		/// <summary>
		/// Valida um login/password no sistema
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns></returns>
		static public ShopStatusEnum ValidateUser(OleDbConnection conn, OleDbTransaction tx, string user, string pass)
		{
			ShopStatusEnum status = ShopStatusEnum.OK;
			OleDbCommand    cmd  = null;

			try
			{
				//
				// criar comando SQL a executar
				//
				cmd = new OleDbCommand("Select * from Users Where User='" + user + "' and Pass='" + pass + "'", conn);
				cmd.Transaction = tx;

				//
				// executar o comando e obter um DataReader
				// poderia ser feito usando um count(*) e um ExecuteScalar()
				//
				OleDbDataReader dr = cmd.ExecuteReader();

				//
				// verificar se retornou dados 
				// ( necessrio manter a conexo aberta pois estamos a usar um DataReader)
				//
				if (dr.HasRows)
					status = ShopStatusEnum.OK;
				else
					status = ShopStatusEnum.INVALID_LOGIN;

				dr.Close();
			}
			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO na validao do 'User': " + ex);
				status = ShopStatusEnum.ERROR;
			}

			return status;
		}
		#endregion

	}
}
